<?php

namespace Drupal\poll_private;

use Drupal\Core\Database\Connection;

class PollPrivateTokenStorage {

  protected $database;

  public function __construct(Connection $database) {
    $this->database = $database;
  }

  public function load($id) {
    return $this->database->select('poll_private_tokens', 'ppt')
      ->fields('ppt')
      ->condition('id', $id)
      ->execute()
      ->fetchObject();
  }

  public function delete($id) {
    $this->database->delete('poll_private_tokens')
      ->condition('id', $id)
      ->execute();
  }

  public function validateToken($poll_id, $token) {
    return (bool) $this->database->select('poll_private_tokens', 'ppt')
      ->condition('poll_id', $poll_id)
      ->condition('token', $token)
      ->condition('used', 0)
      ->countQuery()
      ->execute()
      ->fetchField();
  }

  public function markTokenAsUsed($poll_id, $token) {
    $this->database->update('poll_private_tokens')
      ->fields(['used' => 1])
      ->condition('poll_id', $poll_id)
      ->condition('token', $token)
      ->execute();
  }
}